SystemOrganization addCategory: #'POO-Metaprogramacion1'!

Object subclass: #ClassWithAbstractMethodsAndSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO-Metaprogramacion1'!

!ClassWithAbstractMethodsAndSubclasses class methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 20:03'!
classAbstractMethod
	^self subclassResponsibility ! !

!ClassWithAbstractMethodsAndSubclasses methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 20:03'!
abstractMethod
	^self subclassResponsibility ! !

ClassWithAbstractMethodsAndSubclasses subclass: #OtherSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO-Metaprogramacion1'!

ClassWithAbstractMethodsAndSubclasses subclass: #Subclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO-Metaprogramacion1'!

Subclass subclass: #Subsubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO-Metaprogramacion1'!

Object subclass: #ClassWithAbstractMethodsButNoSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO-Metaprogramacion1'!

!ClassWithAbstractMethodsButNoSubclasses class methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 20:02'!
classAbstractMethod
	^self subclassResponsibility ! !

!ClassWithAbstractMethodsButNoSubclasses methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 20:02'!
abstractMethod
	^self subclassResponsibility ! !

Object subclass: #ClassWithNoAbstractMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO-Metaprogramacion1'!

!ClassWithNoAbstractMethods class methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 20:01'!
classNoAbstractMethod
	^'hola'! !

!ClassWithNoAbstractMethods methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 20:00'!
noAbstracMethod 
	^10! !

Object subclass: #MissingImplementorsFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO-Metaprogramacion1'!

!MissingImplementorsFinder class methodsFor: 'errors' stamp: 'achavez 6/19/2013 20:21'!
methodIsNotAbstract
	^'Method is not abstract'! !

!MissingImplementorsFinder class methodsFor: 'errors' stamp: 'achavez 6/19/2013 21:02'!
methodNotImplementedByClass
	^'Method not implemented by class'! !

!MissingImplementorsFinder methodsFor: 'services' stamp: 'achavez 6/19/2013 21:15'!
lookForMissingImplementorsForClass: aClass selector: aSymbol 
	|compiledMethod list|
	(aClass canUnderstand: aSymbol) ifFalse: [^self error: self class methodNotImplementedByClass]. 
	compiledMethod := aClass lookupSelector: aSymbol.
	compiledMethod isAbstract ifFalse: [ ^self error: self class methodIsNotAbstract ].
	list := OrderedCollection new.
	aClass allSubclassesDo: [ :subclass | 
			(subclass allSubclasses isEmpty and: [ (subclass lookupSelector: aSymbol) isAbstract ]) 
				ifTrue: [ list add: subclass ] ].
	^list
	! !

TestCase subclass: #TestMetaprogramacion1
	instanceVariableNames: 'emptyClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'POO-Metaprogramacion1'!

!TestMetaprogramacion1 methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 19:32'!
setUp 	
	emptyClass := Object subclass: #EmptyClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: ''! !

!TestMetaprogramacion1 methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 20:38'!
test01whenMethodIsNotAbstractAnErrorIsRaisedAndNoListIsReturn
	| list |
	self should: [
		list := MissingImplementorsFinder new 
			lookForMissingImplementorsForClass: ClassWithNoAbstractMethods 
			selector: #noAbstracMethod] 
		raise: Error 
		withExceptionDo: [:anError| self assert: anError messageText = MissingImplementorsFinder methodIsNotAbstract].
	self assert: list isNil 
	! !

!TestMetaprogramacion1 methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 21:03'!
test02whenMethodIsUnderstandByTheClassErrorIsRaisedAndNoListIsReturn
	| list |
	self should: [
		list := MissingImplementorsFinder new 
			lookForMissingImplementorsForClass: ClassWithNoAbstractMethods 
			selector: #abstractMethod] 
		raise: Error 
		withExceptionDo: [:anError| self assert: anError messageText = 
			MissingImplementorsFinder methodNotImplementedByClass].
	self assert: list isNil 
	! !

!TestMetaprogramacion1 methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 21:22'!
test03whenMethodInClassSideIsNotAbstractAnErrorIsRaisedAndNoListIsReturn
	| list |
	"we decided to let the class tests for completeness although we know we're not making TDD"
	self should: [
		list := MissingImplementorsFinder new 
			lookForMissingImplementorsForClass: ClassWithNoAbstractMethods class 
			selector: #classNoAbstractMethod] 
		raise: Error 
		withExceptionDo: [:anError| self assert: anError messageText = MissingImplementorsFinder methodIsNotAbstract].
	self assert: list isNil 
	! !

!TestMetaprogramacion1 methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 21:18'!
test04whenMethodIsAbstractWithNoSubclassesListIsEmpty
	| list |
	list := MissingImplementorsFinder new 
			lookForMissingImplementorsForClass: Subsubclass class
			selector: #classAbstractMethod.
	self assert: list isEmpty
	! !

!TestMetaprogramacion1 methodsFor: 'as yet unclassified' stamp: 'achavez 6/19/2013 21:21'!
test05whenMethodInClassSideIsAbstractWithNoSubclassesListIsEmpty
	| list |
	"we decided to let the class tests for completeness although we know we're not making TDD"
	list := MissingImplementorsFinder new 
			lookForMissingImplementorsForClass: Subsubclass class
			selector: #classAbstractMethod.
	self assert: list isEmpty
	! !
